/// <reference types="react" />
import { ArrayField, BlockField, CheckboxField, CodeField, DateField, EmailField, JSONField, NumberField, PointField, RadioField, RelationshipField, RichTextField, SelectField, TextareaField, TextField, UploadField, Validate } from './config/types';
export declare const number: Validate<unknown, unknown, NumberField>;
export declare const text: Validate<unknown, unknown, TextField>;
export declare const password: Validate<unknown, unknown, TextField>;
export declare const email: Validate<unknown, unknown, EmailField>;
export declare const textarea: Validate<unknown, unknown, TextareaField>;
export declare const code: Validate<unknown, unknown, CodeField>;
export declare const json: Validate<unknown, unknown, JSONField & {
    jsonError?: string;
}>;
export declare const richText: Validate<unknown, unknown, RichTextField>;
export declare const checkbox: Validate<unknown, unknown, CheckboxField>;
export declare const date: Validate<unknown, unknown, DateField>;
export declare const upload: Validate<unknown, unknown, UploadField>;
export declare const relationship: Validate<unknown, unknown, RelationshipField>;
export declare const array: Validate<unknown, unknown, ArrayField>;
export declare const select: Validate<unknown, unknown, SelectField>;
export declare const radio: Validate<unknown, unknown, RadioField>;
export declare const blocks: Validate<unknown, unknown, BlockField>;
export declare const point: Validate<unknown, unknown, PointField>;
declare const _default: {
    number: Validate<unknown, unknown, NumberField>;
    text: Validate<unknown, unknown, TextField>;
    password: Validate<unknown, unknown, TextField>;
    email: Validate<unknown, unknown, EmailField>;
    textarea: Validate<unknown, unknown, TextareaField>;
    code: Validate<unknown, unknown, CodeField>;
    richText: Validate<unknown, unknown, RichTextField>;
    checkbox: Validate<unknown, unknown, CheckboxField>;
    date: Validate<unknown, unknown, DateField>;
    upload: Validate<unknown, unknown, UploadField>;
    relationship: Validate<unknown, unknown, RelationshipField>;
    array: Validate<unknown, unknown, ArrayField>;
    select: Validate<unknown, unknown, SelectField>;
    radio: Validate<unknown, unknown, RadioField>;
    blocks: Validate<unknown, unknown, BlockField>;
    point: Validate<unknown, unknown, PointField>;
    json: Validate<unknown, unknown, Omit<import("./config/types").FieldBase, "admin"> & {
        admin?: {
            position?: "sidebar";
            width?: string;
            style?: import("react").CSSProperties;
            className?: string;
            readOnly?: boolean;
            disabled?: boolean;
            condition?: import("./config/types").Condition<any, any>;
            description?: import("../admin/components/forms/FieldDescription/types").Description;
            components?: {
                Filter?: import("react").ComponentType<any>;
                Cell?: import("react").ComponentType<any>;
                Field?: import("react").ComponentType<any>;
            };
            hidden?: boolean;
        } & {
            editorOptions?: monaco.editor.IStandaloneEditorConstructionOptions;
        };
        type: "json";
    } & {
        jsonError?: string;
    }>;
};
export default _default;
